GENERIC IMPLEMENTATION MODULE Sorts(element : TYPE;
				    lessEq : CompareProc);

PROCEDURE QuickSort(VAR data : ARRAY OF element);
CONST
    cutoffValue	= 10;

    PROCEDURE swap(i, j : CARDINAL);
    VAR
        temp	: element;
    BEGIN
        temp := data[i];
	data[i] := data[j];
	data[j] := temp;
    END swap;

    PROCEDURE quick(left, right : CARDINAL);
    VAR
	j		: CARDINAL;
	k		: CARDINAL;
    BEGIN
	WHILE (left < right) AND ((right-left) > cutoffValue) DO
	    (* median of three optimization *)

	    swap((left+right) / 2, left+1);

	    IF lessEq(data[right], data[left+1], FALSE) THEN
		swap(right, left+1);
	    END;
	    IF lessEq(data[right], data[left], FALSE) THEN
		swap(right, left);
	    END;
	    IF lessEq(data[left], data[left+1], FALSE) THEN
		swap(left, left+1);
	    END;

	    (* split the sequence *)

	    j := left+1;
	    k := right;

	    REPEAT
		REPEAT
		    j := j + 1;
		UNTIL lessEq(data[left], data[j], TRUE);
		REPEAT
		    k := k - 1;
		UNTIL lessEq(data[k], data[left], TRUE);

		IF j < k THEN
		    swap(j, k);
		END;
	    UNTIL j > k;

	    swap(left, k);

	    (* tail recursion optimization *)

	    IF (k-left) < (right-k) THEN
		quick(left, k-1);
		left := k+1;
	    ELSE
		quick(k+1, right);
		right := k-1;
	    END;
	END;
    END quick;

    PROCEDURE insertSort(upper : CARDINAL);
    VAR
	i	: CARDINAL;
	j	: CARDINAL;
    BEGIN
	FOR i := 1 TO upper DO
	    j := i;
	    WHILE (j > 0) AND lessEq(data[j], data[j-1], FALSE) DO
		swap(j, j-1);
		DEC(j);
	    END;
	END;
    END insertSort;

BEGIN
    IF HIGH(data) > 0 THEN
	quick(0, HIGH(data));
	insertSort(HIGH(data));
    END;
END QuickSort;

END Sorts.
